#

API Docs for: v3.8.1
Show: Inherited Protected Private Deprecated

# DS.JSONAPIAdapter Class

Extends DS.RESTAdapter
Defined in: `addon/adapters/json-api.js:10`
Module: ember-data

Available since 1.13.0

The `JSONAPIAdapter` is the default adapter used by Ember Data. It is responsible for transforming the store's requests into HTTP requests that follow the JSON API format.

## JSON API Conventions

The JSONAPIAdapter uses JSON API conventions for building the URL for a record and selecting the HTTP verb to use with a request. The actions you can take on a record map onto the following URLs in the JSON API adapter:

Action | HTTP Verb | URL
--- | --- | ---
`store.findRecord('post', 123)` | GET | /posts/123
`store.findAll('post')` | GET | /posts
Update `postRecord.save()` | PATCH | /posts/123
Create `store.createRecord('post').save()` | POST | /posts
Delete `postRecord.destroyRecord()` | DELETE | /posts/123

## Success and failure

The JSONAPIAdapter will consider a success any response with a status code of the 2xx family ("Success"), as well as 304 ("Not Modified"). Any other status code will be considered a failure.

On success, the request promise will be resolved with the full response payload.

Failed responses with status code 422 ("Unprocessable Entity") will be considered "invalid". The response will be discarded, except for the `errors` key. The request promise will be rejected with a `DS.InvalidError`. This error object will encapsulate the saved `errors` value.

Any other status codes will be treated as an adapter error. The request promise will be rejected, similarly to the invalid case, but with an instance of `DS.AdapterError` instead.

### Endpoint path customization

Endpoint paths can be prefixed with a `namespace` by setting the namespace property on the adapter:

    import DS from 'ember-data';

    export default DS.JSONAPIAdapter.extend({
      namespace: 'api/1'
    });

Requests for the `person` model would now target `/api/1/people/1`.

### Host customization

An adapter can target other hosts by setting the `host` property.

    import DS from 'ember-data';

    export default DS.JSONAPIAdapter.extend({
      host: 'https://api.example.com'
    });

Requests for the `person` model would now target `https://api.example.com/people/1`.

## Constructor

### `DS.JSONAPIAdapter`

()

Defined in `addon/adapters/json-api.js:10`

Available since 1.13.0

- Index
- Methods
- Properties

## Item Index

### Methods

- _ajaxRequest
- _buildURL
- _najaxRequest
- ajax
- ajaxOptions
- buildURL
- createRecord
- deleteRecord
- findAll
- findBelongsTo
- findHasMany
- findMany
- findRecord
- generatedDetailedMessage
- generateIdForRecord
- groupRecordsForFindMany
- handleResponse
- isInvalid
- isSuccess
- normalizeErrorResponse
- parseErrorResponse
- pathForType
- query
- queryRecord
- serialize
- shouldBackgroundReloadAll
- shouldBackgroundReloadRecord
- shouldReloadAll
- shouldReloadRecord
- sortQueryParams
- updateRecord
- urlForCreateRecord
- urlForDeleteRecord
- urlForFindAll
- urlForFindBelongsTo
- urlForFindHasMany
- urlForFindMany
- urlForFindRecord
- urlForQuery
- urlForQueryRecord
- urlForUpdateRecord
- urlPrefix

### Properties

- coalesceFindRequests
- defaultSerializer
- headers
- host
- namespace

## Methods

### `_ajaxRequest`

(

- `options`

)
private

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:1001`

#### Parameters:

- `options` Object
  jQuery ajax options to be used for the ajax request

### `_buildURL`

(

- `modelName`
- `id`

)
String private

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:82`

#### Parameters:

- `modelName` String
- `id` String

#### Returns:

String:

url

### `_najaxRequest`

(

- `options`

)
private

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:1010`

#### Parameters:

- `options` Object
  jQuery ajax options to be used for the najax request

### `ajax`

(

- `url`
- `type`
- `options`

)
Promise private

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:951`

Takes a URL, an HTTP method and a hash of data, and makes an HTTP request. When the server responds with a payload, Ember Data will call into `extractSingle` or `extractArray` (depending on whether the original query was for one record or many records). By default, `ajax` method has the following behavior: * It sets the response `dataType` to `"json"` * If the HTTP method is not `"GET"`, it sets the `Content-Type` to be `application/json; charset=utf-8` * If the HTTP method is not `"GET"`, it stringifies the data passed in. The data is the serialized record in the case of a save. * Registers success and failure handlers.

#### Parameters:

- `url` String
- `type` String
  The request type GET, POST, PUT, DELETE etc.
- `options` Object

#### Returns:

Promise: promise

### `ajaxOptions`

(

- `url`
- `type`
- `options`

)
Object private

Inherited from DS.RESTAdapter but overwritten in `addon/adapters/json-api.js:149`

#### Parameters:

- `url` String
- `type` String

  The request type GET, POST, PUT, DELETE etc.

- `options` Object

#### Returns:

Object:

### `buildURL`

(

- `modelName`
- `id`
- `snapshot`
- `requestType`
- `query`

)
String

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:34`

Builds a URL for a given type and optional ID.

By default, it pluralizes the type's name (for example, 'post' becomes 'posts' and 'person' becomes 'people'). To override the pluralization see pathForType.

If an ID is specified, it adds the ID to the path generated for the type, separated by a `/`.

When called by `RESTAdapter.findMany()` the `id` and `snapshot` parameters will be arrays of ids and snapshots.

#### Parameters:

- `modelName` String
- `id` (String | Array | Object)

  single id or array of ids or query

- `snapshot` (DS.Snapshot | Array)

  single snapshot or array of snapshots

- `requestType` String
- `query` Object

  object of query parameters to send for query requests.

#### Returns:

String:

url

### `createRecord`

(

- `store`
- `type`
- `snapshot`

)
Promise

Inherited from DS.Adapter but overwritten in `addon/adapters/rest.js:698`

Called by the store when a newly created record is saved via the `save` method on a model record instance. The `createRecord` method serializes the record and makes an Ajax (HTTP POST) request to a URL computed by `buildURL`. See `serialize` for information on how to customize the serialized form of a record.

#### Parameters:

- `store` DS.Store
- `type` DS.Model
- `snapshot` DS.Snapshot

#### Returns:

Promise: promise

### `deleteRecord`

(

- `store`
- `type`
- `snapshot`

)
Promise

Inherited from DS.Adapter but overwritten in `addon/adapters/rest.js:752`

Called by the store when a record is deleted. The `deleteRecord` method makes an Ajax (HTTP DELETE) request to a URL computed by `buildURL`.

#### Parameters:

- `store` DS.Store
- `type` DS.Model
- `snapshot` DS.Snapshot

#### Returns:

Promise: promise

### `findAll`

(

- `store`
- `type`
- `sinceToken`
- `snapshotRecordArray`

)
Promise

Inherited from DS.Adapter but overwritten in `addon/adapters/rest.js:491`

Called by the store in order to fetch a JSON array for all of the records for a given type. The `findAll` method makes an Ajax (HTTP GET) request to a URL computed by `buildURL`, and returns a promise for the resulting payload.

#### Parameters:

- `store` DS.Store
- `type` DS.Model
- `sinceToken` String
- `snapshotRecordArray` DS.SnapshotRecordArray

#### Returns:

Promise: promise

### `findBelongsTo`

(

- `store`
- `snapshot`
- `url`
- `relationship`

)
Promise

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:654`

Called by the store in order to fetch the JSON for the unloaded record in a belongs-to relationship that was originally specified as a URL (inside of `links`). For example, if your original payload looks like this: ```js { "person": { "id": 1, "name": "Tom Dale", "links": { "group": "/people/1/group" } } } ``` This method will be called with the parent record and `/people/1/group`. The `findBelongsTo` method will make an Ajax (HTTP GET) request to the originally specified URL. The format of your `links` value will influence the final request URL via the `urlPrefix` method: * Links beginning with `//`, `http://`, `https://`, will be used as is, with no further manipulation. * Links beginning with a single `/` will have the current adapter's `host` value prepended to it. * Links with no beginning `/` will have a parentURL prepended to it, via the current adapter's `buildURL`.

#### Parameters:

- `store` DS.Store
- `snapshot` DS.Snapshot
- `url` String
- `relationship` Object
  meta object describing the relationship

#### Returns:

Promise: promise

### `findHasMany`

(

- `store`
- `snapshot`
- `url`
- `relationship`

)
Promise

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:609`

Called by the store in order to fetch a JSON array for the unloaded records in a has-many relationship that were originally specified as a URL (inside of `links`). For example, if your original payload looks like this: ```js { "post": { "id": 1, "title": "Rails is omakase", "links": { "comments": "/posts/1/comments" } } } ``` This method will be called with the parent record and `/posts/1/comments`. The `findHasMany` method will make an Ajax (HTTP GET) request to the originally specified URL. The format of your `links` value will influence the final request URL via the `urlPrefix` method: * Links beginning with `//`, `http://`, `https://`, will be used as is, with no further manipulation. * Links beginning with a single `/` will have the current adapter's `host` value prepended to it. * Links with no beginning `/` will have a parentURL prepended to it, via the current adapter's `buildURL`.

#### Parameters:

- `store` DS.Store
- `snapshot` DS.Snapshot
- `url` String
- `relationship` Object
  meta object describing the relationship

#### Returns:

Promise: promise

### `findMany`

(

- `store`
- `type`
- `ids`
- `snapshots`

)
Promise

Inherited from DS.Adapter but overwritten in `addon/adapters/rest.js:571`

Called by the store in order to fetch several records together if `coalesceFindRequests` is true For example, if the original payload looks like: ```js { "id": 1, "title": "Rails is omakase", "comments": [ 1, 2, 3 ] } ``` The IDs will be passed as a URL-encoded Array of IDs, in this form: ``` ids[]=1&ids[]=2&ids[]=3 ``` Many servers, such as Rails and PHP, will automatically convert this URL-encoded array into an Array for you on the server-side. If you want to encode the IDs, differently, just override this (one-line) method. The `findMany` method makes an Ajax (HTTP GET) request to a URL computed by `buildURL`, and returns a promise for the resulting payload.

#### Parameters:

- `store` DS.Store
- `type` DS.Model
- `ids` Array
- `snapshots` Array

#### Returns:

Promise: promise

### `findRecord`

(

- `store`
- `type`
- `id`
- `snapshot`

)
Promise

Inherited from DS.Adapter but overwritten in `addon/adapters/rest.js:467`

Available since 1.13.0

Called by the store in order to fetch the JSON for a given type and ID. The `findRecord` method makes an Ajax request to a URL computed by `buildURL`, and returns a promise for the resulting payload. This method performs an HTTP `GET` request with the id provided as part of the query string.

#### Parameters:

- `store` DS.Store
- `type` DS.Model
- `id` String
- `snapshot` DS.Snapshot

#### Returns:

Promise: promise

### `generatedDetailedMessage`

(

- `status`
- `headers`
- `payload`
- `requestData`

)
String private

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:1144`

Generates a detailed ("friendly") error message, with plenty of information for debugging (good luck!)

#### Parameters:

- `status` Number
- `headers` Object
- `payload` Object
- `requestData` Object

#### Returns:

String: detailed error message

### `generateIdForRecord`

(

- `store`
- `type`
- `inputProperties`

)
(String | Number)

Inherited from DS.Adapter: `addon/adapter.js:226`

If the globally unique IDs for your records should be generated on the client, implement the `generateIdForRecord()` method. This method will be invoked each time you create a new record, and the value returned from it will be assigned to the record's `primaryKey`. Most traditional REST-like HTTP APIs will not use this method. Instead, the ID of the record will be set by the server, and your adapter will update the store with the new ID when it calls `didCreateRecord()`. Only implement this method if you intend to generate record IDs on the client-side. The `generateIdForRecord()` method will be invoked with the requesting store as the first parameter and the newly created record as the second parameter: ```javascript import DS from 'ember-data'; import { v4 } from 'uuid'; export default DS.Adapter.extend({ generateIdForRecord(store, inputProperties) { return v4(); } }); ```

#### Parameters:

- `store` DS.Store
- `type` DS.Model
  the DS.Model class of the record
- `inputProperties` Object
  a hash of properties to set on the newly created record.

#### Returns:

(String | Number): id

### `groupRecordsForFindMany`

(

- `store`
- `snapshots`

)
Array

Inherited from DS.Adapter but overwritten in `addon/adapters/rest.js:796`

Organize records into groups, each of which is to be passed to separate calls to `findMany`. This implementation groups together records that have the same base URL but differing ids. For example `/comments/1` and `/comments/2` will be grouped together because we know findMany can coalesce them together as `/comments?ids[]=1&ids[]=2` It also supports urls where ids are passed as a query param, such as `/comments?id=1` but not those where there is more than 1 query param such as `/comments?id=2&name=David` Currently only the query param of `id` is supported. If you need to support others, please override this or the `_stripIDFromURL` method. It does not group records that have differing base urls, such as for example: `/posts/1/comments/2` and `/posts/2/comments/3`

#### Parameters:

- `store` DS.Store
- `snapshots` Array

#### Returns:

Array: an array of arrays of records, each of which is to be loaded separately by `findMany`.

### `handleResponse`

(

- `status`
- `headers`
- `payload`
- `requestData`

)
Object | DS.AdapterError

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:864`

Available since 1.13.0

Takes an ajax response, and returns the json payload or an error. By default this hook just returns the json payload passed to it. You might want to override it in two cases: 1. Your API might return useful results in the response headers. Response headers are passed in as the second argument. 2. Your API might return errors as successful responses with status code 200 and an Errors text or object. You can return a `DS.InvalidError` or a `DS.AdapterError` (or a sub class) from this hook and it will automatically reject the promise and put your record into the invalid or error state. Returning a `DS.InvalidError` from this method will cause the record to transition into the `invalid` state and make the `errors` object available on the record. When returning an `DS.InvalidError` the store will attempt to normalize the error data returned from the server using the serializer's `extractErrors` method.

#### Parameters:

- `status` Number
- `headers` Object
- `payload` Object
- `requestData` Object
  - the original request information

#### Returns:

Object | DS.AdapterError: response

### `isInvalid`

(

- `status`
- `headers`
- `payload`

)
Boolean

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:936`

Available since 1.13.0

Default `handleResponse` implementation uses this hook to decide if the response is an invalid error.

#### Parameters:

- `status` Number
- `headers` Object
- `payload` Object

#### Returns:

Boolean:

### `isSuccess`

(

- `status`
- `headers`
- `payload`

)
Boolean

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:921`

Available since 1.13.0

Default `handleResponse` implementation uses this hook to decide if the response is a success.

#### Parameters:

- `status` Number
- `headers` Object
- `payload` Object

#### Returns:

Boolean:

### `normalizeErrorResponse`

(

- `status`
- `headers`
- `payload`

)
Array private

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:1122`

#### Parameters:

- `status` Number
- `headers` Object
- `payload` Object

#### Returns:

Array: errors payload

### `parseErrorResponse`

(

- `responseText`

)
Object private

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:1104`

#### Parameters:

- `responseText` String

#### Returns:

Object:

### `pathForType`

(

- `modelName`

)
String

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:421`

Determines the pathname for a given type.

By default, it pluralizes the type's name (for example, 'post' becomes 'posts' and 'person' becomes 'people').

### Pathname customization

For example, if you have an object `LineItem` with an endpoint of `/line_items/`.

    import DS from 'ember-data';
    import { decamelize } from '@ember/string';
    import { pluralize } from 'ember-inflector';

    export default DS.RESTAdapter.extend({
      pathForType: function(modelName) {
        var decamelized = decamelize(modelName);
        return pluralize(decamelized);
      }
    });

#### Parameters:

- `modelName` String

#### Returns:

String:

path

### `query`

(

- `store`
- `type`
- `query`

)
Promise

Inherited from DS.Adapter but overwritten in `addon/adapters/rest.js:516`

Called by the store in order to fetch a JSON array for the records that match a particular query. The `query` method makes an Ajax (HTTP GET) request to a URL computed by `buildURL`, and returns a promise for the resulting payload. The `query` argument is a simple JavaScript object that will be passed directly to the server as parameters.

#### Parameters:

- `store` DS.Store
- `type` DS.Model
- `query` Object

#### Returns:

Promise: promise

### `queryRecord`

(

- `store`
- `type`
- `query`

)
Promise

Inherited from DS.Adapter but overwritten in `addon/adapters/rest.js:543`

Available since 1.13.0

Called by the store in order to fetch a JSON object for the record that matches a particular query. The `queryRecord` method makes an Ajax (HTTP GET) request to a URL computed by `buildURL`, and returns a promise for the resulting payload. The `query` argument is a simple JavaScript object that will be passed directly to the server as parameters.

#### Parameters:

- `store` DS.Store
- `type` DS.Model
- `query` Object

#### Returns:

Promise: promise

### `serialize`

(

- `snapshot`
- `options`

)
Object

Inherited from DS.Adapter: `addon/adapter.js:260`

Proxies to the serializer's `serialize` method. Example ```app/adapters/application.js import DS from 'ember-data'; export default DS.Adapter.extend({ createRecord(store, type, snapshot) { let data = this.serialize(snapshot, { includeId: true }); let url = `/${type.modelName}`; // ... } }); ```

#### Parameters:

- `snapshot` DS.Snapshot
- `options` Object

#### Returns:

Object: serialized snapshot

### `shouldBackgroundReloadAll`

(

- `store`
- `snapshotRecordArray`

)
Boolean

Inherited from DS.Adapter: `addon/adapter.js:640`

Available since 1.13.0

This method is used by the store to determine if the store should reload a record array after the `store.findAll` method resolves with a cached record array. This method is *only* checked by the store when the store is returning a cached record array. If this method returns `true` the store will re-fetch all records from the adapter. For example, if you do not want to fetch complex data over a mobile connection, or if the network is down, you can implement `shouldBackgroundReloadAll` as follows: ```javascript shouldBackgroundReloadAll(store, snapshotArray) { let connection = window.navigator.connection; if (connection === 'cellular' || connection === 'none') { return false; } else { return true; } } ``` By default this method returns `true`, indicating that a background reload should always be triggered.

#### Parameters:

- `store` DS.Store
- `snapshotRecordArray` DS.SnapshotRecordArray

#### Returns:

Boolean:

### `shouldBackgroundReloadRecord`

(

- `store`
- `snapshot`

)
Boolean

Inherited from DS.Adapter: `addon/adapter.js:600`

Available since 1.13.0

This method is used by the store to determine if the store should reload a record after the `store.findRecord` method resolves a cached record. This method is *only* checked by the store when the store is returning a cached record. If this method returns `true` the store will re-fetch a record from the adapter. For example, if you do not want to fetch complex data over a mobile connection, or if the network is down, you can implement `shouldBackgroundReloadRecord` as follows: ```javascript shouldBackgroundReloadRecord(store, snapshot) { let connection = window.navigator.connection; if (connection === 'cellular' || connection === 'none') { return false; } else { return true; } } ``` By default, this hook returns `true` so the data for the record is updated in the background.

#### Parameters:

- `store` DS.Store
- `snapshot` DS.Snapshot

#### Returns:

Boolean:

### `shouldReloadAll`

(

- `store`
- `snapshotRecordArray`

)
Boolean

Inherited from DS.Adapter: `addon/adapter.js:545`

Available since 1.13.0

This method is used by the store to determine if the store should reload all records from the adapter when records are requested by `store.findAll`. If this method returns `true`, the store will re-fetch all records from the adapter. If this method returns `false`, the store will resolve immediately using the cached records. For example, if you are building an events ticketing system, in which users can only reserve tickets for 20 minutes at a time, and want to ensure that in each route you have data that is no more than 20 minutes old you could write: ```javascript shouldReloadAll(store, snapshotArray) { let snapshots = snapshotArray.snapshots(); return snapshots.any((ticketSnapshot) => { let lastAccessedAt = ticketSnapshot.attr('lastAccessedAt'); let timeDiff = moment().diff(lastAccessedAt, 'minutes'); if (timeDiff > 20) { return true; } else { return false; } }); } ``` This method would ensure that whenever you do `store.findAll('ticket')` you will always get a list of tickets that are no more than 20 minutes old. In case a cached version is more than 20 minutes old, `findAll` will not resolve until you fetched the latest versions. By default, this method returns `true` if the passed `snapshotRecordArray` is empty (meaning that there are no records locally available yet), otherwise, it returns `false`. Note that, with default settings, `shouldBackgroundReloadAll` will always re-fetch all the records in the background even if `shouldReloadAll` returns `false`. You can override `shouldBackgroundReloadAll` if this does not suit your use case.

#### Parameters:

- `store` DS.Store
- `snapshotRecordArray` DS.SnapshotRecordArray

#### Returns:

Boolean:

### `shouldReloadRecord`

(

- `store`
- `snapshot`

)
Boolean

Inherited from DS.Adapter: `addon/adapter.js:495`

Available since 1.13.0

This method is used by the store to determine if the store should reload a record from the adapter when a record is requested by `store.findRecord`. If this method returns `true`, the store will re-fetch a record from the adapter. If this method returns `false`, the store will resolve immediately using the cached record. For example, if you are building an events ticketing system, in which users can only reserve tickets for 20 minutes at a time, and want to ensure that in each route you have data that is no more than 20 minutes old you could write: ```javascript shouldReloadRecord(store, ticketSnapshot) { let lastAccessedAt = ticketSnapshot.attr('lastAccessedAt'); let timeDiff = moment().diff(lastAccessedAt, 'minutes'); if (timeDiff > 20) { return true; } else { return false; } } ``` This method would ensure that whenever you do `store.findRecord('ticket', id)` you will always get a ticket that is no more than 20 minutes old. In case the cached version is more than 20 minutes old, `findRecord` will not resolve until you fetched the latest version. By default this hook returns `false`, as most UIs should not block user interactions while waiting on data update. Note that, with default settings, `shouldBackgroundReloadRecord` will always re-fetch the records in the background even if `shouldReloadRecord` returns `false`. You can override `shouldBackgroundReloadRecord` if this does not suit your use case.

#### Parameters:

- `store` DS.Store
- `snapshot` DS.Snapshot

#### Returns:

Boolean:

### `sortQueryParams`

(

- `obj`

)
Object

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:301`

By default, the RESTAdapter will send the query params sorted alphabetically to the server. For example: ```js store.query('posts', { sort: 'price', category: 'pets' }); ``` will generate a requests like this `/posts?category=pets&sort=price`, even if the parameters were specified in a different order. That way the generated URL will be deterministic and that simplifies caching mechanisms in the backend. Setting `sortQueryParams` to a falsey value will respect the original order. In case you want to sort the query parameters with a different criteria, set `sortQueryParams` to your custom sort function. ```app/adapters/application.js import DS from 'ember-data'; export default DS.RESTAdapter.extend({ sortQueryParams(params) { let sortedKeys = Object.keys(params).sort().reverse(); let len = sortedKeys.length, newParams = {}; for (let i = 0; i < len; i++) { newParams[sortedKeys[i]] = params[sortedKeys[i]]; } return newParams; } }); ```

#### Parameters:

- `obj` Object

#### Returns:

Object:

### `updateRecord`

(

- `store`
- `type`
- `snapshot`

)
Promise

Inherited from DS.Adapter but overwritten in `addon/adapters/rest.js:724`

Called by the store when an existing record is saved via the `save` method on a model record instance. The `updateRecord` method serializes the record and makes an Ajax (HTTP PUT) request to a URL computed by `buildURL`. See `serialize` for information on how to customize the serialized form of a record.

#### Parameters:

- `store` DS.Store
- `type` DS.Model
- `snapshot` DS.Snapshot

#### Returns:

Promise: promise

### `urlForCreateRecord`

(

- `modelName`
- `snapshot`

)
String

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:305`

Builds a URL for a `record.save()` call when the record was created locally using `store.createRecord()`.

Example:

    import DS from 'ember-data';

    export default DS.RESTAdapter.extend({
      urlForCreateRecord(modelName, snapshot) {
        return this._super(...arguments) + '/new';
      }
    });

#### Parameters:

- `modelName` String
- `snapshot` DS.Snapshot

#### Returns:

String:

url

### `urlForDeleteRecord`

(

- `id`
- `modelName`
- `snapshot`

)
String

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:355`

Builds a URL for a `record.save()` call when the record has been deleted locally.

Example:

    import DS from 'ember-data';

    export default DS.RESTAdapter.extend({
      urlForDeleteRecord(id, modelName, snapshot) {
        return this._super(...arguments) + '/destroy';
      }
    });

#### Parameters:

- `id` String
- `modelName` String
- `snapshot` DS.Snapshot

#### Returns:

String:

url

### `urlForFindAll`

(

- `modelName`
- `snapshot`

)
String

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:144`

Builds a URL for a `store.findAll(type)` call.

Example:

    import DS from 'ember-data';

    export default DS.JSONAPIAdapter.extend({
      urlForFindAll(modelName, snapshot) {
        return 'data/comments.json';
      }
    });

#### Parameters:

- `modelName` String
- `snapshot` DS.SnapshotRecordArray

#### Returns:

String:

url

### `urlForFindBelongsTo`

(

- `id`
- `modelName`
- `snapshot`

)
String

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:278`

Builds a URL for fetching an async `belongsTo` relationship when a url is not provided by the server.

Example:

    import DS from 'ember-data';

    export default DS.JSONAPIAdapter.extend({
      urlForFindBelongsTo(id, modelName, snapshot) {
        let baseUrl = this.buildURL(modelName, id);
        return ${baseUrl}/relationships;
      }
    });

#### Parameters:

- `id` String
- `modelName` String
- `snapshot` DS.Snapshot

#### Returns:

String:

url

### `urlForFindHasMany`

(

- `id`
- `modelName`
- `snapshot`

)
String

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:251`

Builds a URL for fetching an async `hasMany` relationship when a URL is not provided by the server.

Example:

    import DS from 'ember-data';

    export default DS.JSONAPIAdapter.extend({
      urlForFindHasMany(id, modelName, snapshot) {
        let baseUrl = this.buildURL(modelName, id);
        return ${baseUrl}/relationships;
      }
    });

#### Parameters:

- `id` String
- `modelName` String
- `snapshot` DS.Snapshot

#### Returns:

String:

url

### `urlForFindMany`

(

- `ids`
- `modelName`
- `snapshots`

)
String

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:223`

Builds a URL for coalescing multiple `store.findRecord(type, id)` records into 1 request when the adapter's `coalesceFindRequests` property is `true`.

Example:

    import DS from 'ember-data';

    export default DS.RESTAdapter.extend({
      urlForFindMany(ids, modelName) {
        let baseUrl = this.buildURL();
        return ${baseUrl}/coalesce;
      }
    });

#### Parameters:

- `ids` Array
- `modelName` String
- `snapshots` Array

#### Returns:

String:

url

### `urlForFindRecord`

(

- `id`
- `modelName`
- `snapshot`

)
String

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:117`

Builds a URL for a `store.findRecord(type, id)` call.

Example:

    import DS from 'ember-data';

    export default DS.JSONAPIAdapter.extend({
      urlForFindRecord(id, modelName, snapshot) {
        let baseUrl = this.buildURL(modelName, id, snapshot);
        return ${baseUrl}/users/${snapshot.adapterOptions.user_id}/playlists/${id};
      }
    });

#### Parameters:

- `id` String
- `modelName` String
- `snapshot` DS.Snapshot

#### Returns:

String:

url

### `urlForQuery`

(

- `query`
- `modelName`

)
String

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:168`

Builds a URL for a `store.query(type, query)` call.

Example:

    import DS from 'ember-data';

    export default DS.RESTAdapter.extend({
      host: 'https://api.github.com',
      urlForQuery (query, modelName) {
        switch(modelName) {
          case 'repo':
            return https://api.github.com/orgs/${query.orgId}/repos;
          default:
            return this._super(...arguments);
        }
      }
    });

#### Parameters:

- `query` Object
- `modelName` String

#### Returns:

String:

url

### `urlForQueryRecord`

(

- `query`
- `modelName`

)
String

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:198`

Builds a URL for a `store.queryRecord(type, query)` call.

Example:

    import DS from 'ember-data';

    export default DS.RESTAdapter.extend({
      urlForQueryRecord({ slug }, modelName) {
        let baseUrl = this.buildURL();
        return ${baseUrl}/${encodeURIComponent(slug)};
      }
    });

#### Parameters:

- `query` Object
- `modelName` String

#### Returns:

String:

url

### `urlForUpdateRecord`

(

- `id`
- `modelName`
- `snapshot`

)
String

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:330`

Builds a URL for a `record.save()` call when the record has been updated locally.

Example:

    import DS from 'ember-data';

    export default DS.RESTAdapter.extend({
      urlForUpdateRecord(id, modelName, snapshot) {
        return /${id}/feed?access_token=${snapshot.adapterOptions.token};
      }
    });

#### Parameters:

- `id` String
- `modelName` String
- `snapshot` DS.Snapshot

#### Returns:

String:

url

### `urlPrefix`

(

- `path`
- `parentURL`

)
String private

Inherited from DS.BuildURLMixin: `addon/-private/adapters/build-url-mixin.js:380`

#### Parameters:

- `path` String
- `parentURL` String

#### Returns:

String:

urlPrefix

## Properties

### `coalesceFindRequests`

Boolean

Inherited from DS.Adapter but overwritten in `addon/adapters/json-api.js:191`

By default the JSONAPIAdapter will send each find request coming from a `store.find` or from accessing a relationship separately to the server. If your server supports passing ids as a query string, you can set coalesceFindRequests to true to coalesce all find requests within a single runloop.

For example, if you have an initial payload of:

    {
      data: {
        id: 1,
        type: 'post',
        relationship: {
          comments: {
            data: [
              { id: 1, type: 'comment' },
              { id: 2, type: 'comment' }
            ]
          }
        }
      }
    }

By default calling `post.get('comments')` will trigger the following requests(assuming the comments haven't been loaded before):

    GET /comments/1
    GET /comments/2

If you set coalesceFindRequests to `true` it will instead trigger the following request:

    GET /comments?filter[id]=1,2

Setting coalesceFindRequests to `true` also works for `store.find` requests and `belongsTo` relationships accessed within the same runloop. If you set `coalesceFindRequests: true`

    store.findRecord('comment', 1);
    store.findRecord('comment', 2);

will also send a request to: `GET /comments?filter[id]=1,2`

Note: Requests coalescing rely on URL building strategy. So if you override `buildURL` in your app `groupRecordsForFindMany` more likely should be overridden as well in order for coalescing to work.

### `defaultSerializer`

String

Inherited from DS.Adapter: `addon/adapter.js:64`

If you would like your adapter to use a custom serializer you can set the `defaultSerializer` property to be the name of the custom serializer. Note the `defaultSerializer` serializer has a lower priority than a model specific serializer (i.e. `PostSerializer`) or the `application` serializer. ```app/adapters/django.js import DS from 'ember-data'; export default DS.Adapter.extend({ defaultSerializer: 'django' }); ```

### `headers`

Object

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:442`

Some APIs require HTTP headers, e.g. to provide an API key. Arbitrary headers can be set as key/value pairs on the `RESTAdapter`'s `headers` object and Ember Data will send them along with each ajax request. For dynamic headers see [headers customization](/api/data/classes/DS.RESTAdapter.html). ```app/adapters/application.js import DS from 'ember-data'; import { computed } from '@ember/object'; export default DS.RESTAdapter.extend({ headers: computed(function() { return { 'API_KEY': 'secret key', 'ANOTHER_HEADER': 'Some header value' }; }) }); ```

### `host`

String

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:425`

An adapter can target other hosts by setting the `host` property. ```app/adapters/application.js import DS from 'ember-data'; export default DS.RESTAdapter.extend({ host: 'https://api.example.com' }); ``` Requests for the `Post` model would now target `https://api.example.com/post/`.

### `namespace`

String

Inherited from DS.RESTAdapter: `addon/adapters/rest.js:407`

Endpoint paths can be prefixed with a `namespace` by setting the namespace property on the adapter: ```app/adapters/application.js import DS from 'ember-data'; export default DS.RESTAdapter.extend({ namespace: 'api/1' }); ``` Requests for the `Post` model would now target `/api/1/post/`.